### Method

# Gck Session unwrap_key

#### Declaration [src]

    GckObject*
    gck_session_unwrap_key (
      GckSession* self,
      GckObject* wrapper,
      gulong mech_type,
      const guchar* input,
      gsize n_input,
      GckAttributes* attrs,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Unwrap a key from a byte stream. This call may block for an indefinite period.

#### Parameters

`wrapper`

  Type: `GckObject`

  The key to use for unwrapping.

  The data is owned by the caller of the method.

`mech_type`

  Type: `gulong`

  The mechanism to use for unwrapping.

`input`

  Type: An array of `guchar`

  The wrapped data as a byte stream.

  The length of the array is specified in the `n_input` argument.
  The data is owned by the caller of the method.

`n_input`

  Type: `gsize`

  The length of the wrapped data.

`attrs`

  Type: `GckAttributes`

  Additional attributes for the unwrapped key.

  The data is owned by the caller of the method.

`cancellable`

  Type: `GCancellable`

  Optional cancellation object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GckObject`

The new unwrapped key or `NULL` if the operation failed.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.